From cb11aaa2a0513e0ff424e0d4c2ae899164e7a0b1 Mon Sep 17 00:00:00 2001
From: barracuda156 <vital.had@gmail.com>
Date: Mon, 21 Nov 2022 01:13:02 +0800
Subject: [PATCH 2/2] core_unix_stubs.c: add legacysupport header for strnlen

---
 core_unix/src/core_unix_stubs.c | 7 +++++++
 1 file changed, 7 insertions(+)

diff --git a/core_unix/src/core_unix_stubs.c b/core_unix/src/core_unix_stubs.c
index 4beba77..20976d2 100644
--- a/core_unix/src/core_unix_stubs.c
+++ b/core_unix/src/core_unix_stubs.c
@@ -64,6 +64,13 @@
 #include <wordexp.h>
 #endif
 
+#if defined(__APPLE__)
+#include <AvailabilityMacros.h>
+#if MAC_OS_X_VERSION_MAX_ALLOWED <= 1060
+#include <LegacySupport/string.h>
+#endif
+#endif
+
 CAMLprim value core_unix_error_of_code(value code)
 {
   return unix_error_of_code(Int_val(code));

--- a/core_unix/src/dune	2023-04-25 21:12:26.000000000 +0800
+++ b/core_unix/src/dune	2023-10-25 20:09:45.000000000 +0800
@@ -1,10 +1,10 @@
 (library (name core_unix) (public_name core_unix)
  (libraries core error_checking_mutex core_kernel.flags sexplib.unix
-  signal_unix spawn)
+  signal_unix spawn) (c_library_flags -lMacportsLegacySupport)
  (c_flags (:standard -D_LARGEFILE64_SOURCE) ())
  (c_names nss_stubs timespec core_unix_stubs core_unix_time_stubs)
  (preprocess (pps ppx_jane ppx_optcomp)) (preprocessor_deps config.h))
 
 (rule (targets config.h thread_id.h) (deps)
  (action
-  (bash "cp %{lib:jst-config:config.h} %{lib:jst-config:thread_id.h} .")))
\ No newline at end of file
+  (bash "cp %{lib:jst-config:config.h} %{lib:jst-config:thread_id.h} .")))
